pangomm: Pango::Context Class Reference

# Pango::Context Class Reference

A Pango::Context stores global information used to control the itemization process. More...

Inherits Glib::Object.

Collaboration diagram for Pango::Context:
[legend]

List of all members.

## Public Member Functions
virtual | ~Context ()
PangoContext* | gobj ()
| Provides access to the underlying C GObject.
const PangoContext* | gobj () const
| Provides access to the underlying C GObject.
PangoContext* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::ArrayHandle < Glib::RefPtr< FontFamily > > | list_families () const
| List all available font families for a context.
void | set_font_map (const Glib::RefPtr< FontMap >& font_map)
| Sets the font map to be searched when fonts are looked-up in this context.
Glib::RefPtr< FontMap > | get_font_map ()
| Gets the Pango::Fontmap used to look up fonts for this context.
Glib::RefPtr< const FontMap > | get_font_map () const
| Gets the Pango::Fontmap used to look up fonts for this context.
Glib::RefPtr< Font > | load_font (const FontDescription& desc) const
| Loads the font in one of the fontmaps in the context that is the closest match for desc.
Glib::RefPtr< Fontset > | load_fontset (const FontDescription& desc, const Language& language) const
| Load a set of fonts in the context that can be used to render a font matching desc.
FontMetrics | get_metrics (const FontDescription& desc) const
| Get overall metric information for a particular font description.
FontMetrics | get_metrics (const FontDescription& desc, const Language& language) const
| Get overall metric information for a font particular font description.
void | set_font_description (const FontDescription& desc)
| Set the default font description for the context.
FontDescription | get_font_description () const
| Retrieve the default font description for the context.
Language | get_language () const
| Retrieves the global language tag for the context.
void | set_language (const Language& language)
| Sets the global language tag for the context.
void | set_base_dir (Direction direction)
| Sets the base direction for the context.
Direction | get_base_dir () const
| Retrieves the base direction for the context.
void | set_base_gravity (Gravity gravity)
| Sets the base gravity for the context.
Gravity | get_base_gravity () const
| Retrieves the base gravity for the context.
Gravity | get_gravity () const
| Retrieves the gravity for the context.
void | set_gravity_hint (GravityHint hint)
| Sets the gravity hint for the context.
GravityHint | get_gravity_hint () const
| Retrieves the gravity hint for the context.
void | set_matrix (const Matrix& matrix)
| Sets the transformation matrix that will be applied when rendering with this context.
Matrix | get_matrix () const
ListHandle_Item | itemize (const Glib::ustring& text, const AttrList& attrs) const
| Breaks a piece of text into segments with consistent directional level and shaping engine.
ListHandle_Item | itemize (const Glib::ustring& text, int start_index, int length, const AttrList& attrs, AttrIter& cached_iter) const
| Breaks a piece of text into segments with consistent directional level and shaping engine.
void | update_from_cairo_context (const Cairo::RefPtr< Cairo::Context >& context)
| Updates a Pango Context previously created for use with Cairo to match the current transformation and target surface of a Cairo Context.
void | set_cairo_font_options (const Cairo::FontOptions& options)
| Sets the font options used when rendering text with this context.
Cairo::FontOptions | get_font_options () const
| Retrieves any font rendering options previously set with pango_cairo_font_map_set_font_options().
void | set_resolution (double dpi)
| Sets the resolution for the context.
double | get_resolution () const
| Gets the resolution for the context.
## Protected Member Functions
| Context ()
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Pango::Context > | wrap (PangoContext* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A Pango::Context stores global information used to control the itemization process.

You can retrieve a Pango::Context object with Gtk::Widget::create_pango_context() or Gtk::Widget::get_pango_context(). If you don't use gtkmm call some c function of the pango backend you intend to use and create a wrapper for the returned context, e.g. Glib::wrap(pango_x_get_context()).

Creating a Pango::Context object is the starting point of every rendering process. You can either use it to create a high level Pango::Layout object which does all the hard work for you by passing it into Pango::Layout::create() or to generate glyph strings from character strings with the help of itemize() and Pango::Item::shape() subsequently.

Which fonts are used for rendering can be influenced by setting the default font description, language and base direction of the context.

If you want to calculate the space some text will need to be displayed you might find the functions of Pango::FontMetrics useful. Use get_metrics() to obtain the Pango::FontMetrics object for a specific Pango::FontDescription. For more detailed calculations in a rendering-system-independant manner and to determine whether specific characters can be represented by the font that would be used for a specific Pango::FontDescription load a Pango::Fontset with load_fontset() (load_font() returns the Pango::Font that is the closest match for a Pango::FontDescription; however that's not necessarily the font that will be used for rendering).

## Constructor & Destructor Documentation

virtual Pango::Context::~Context | ( |  | ) | `[virtual]`

Pango::Context::Context | ( |  | ) | `[protected]`

## Member Function Documentation

Direction Pango::Context::get_base_dir | ( |  | ) | const

Retrieves the base direction for the context.

See pango_context_set_base_dir().

Returns:
  The base direction for the context.

Gravity Pango::Context::get_base_gravity | ( |  | ) | const

Retrieves the base gravity for the context.

See pango_context_set_base_gravity().

Returns:
  The base gravity for the context.

Since pangomm 1.16:

FontDescription Pango::Context::get_font_description | ( |  | ) | const

Retrieve the default font description for the context.

Returns:
  A pointer to the context's default font description. This value must not be modified or freed.

Glib::RefPtr<const FontMap> Pango::Context::get_font_map | ( |  | ) | const

Gets the Pango::Fontmap used to look up fonts for this context.

Returns:
  The font map for the Pango::Context. This value is owned by Pango and should not be unreferenced.

Since pangomm 1.6:

Glib::RefPtr<FontMap> Pango::Context::get_font_map | ( |  | ) |

Gets the Pango::Fontmap used to look up fonts for this context.

Returns:
  The font map for the Pango::Context. This value is owned by Pango and should not be unreferenced.

Since pangomm 1.6:

Cairo::FontOptions Pango::Context::get_font_options | ( |  | ) | const

Retrieves any font rendering options previously set with pango_cairo_font_map_set_font_options().

This function does not report options that are derived from the target surface by pango_cairo_update_context()

Parameters:

  | context | A Pango::Context, from a pangocairo font map.

Returns:
  The font options previously set on the context, or `0` if no options have been set. This value is owned by the context and must not be modified or freed.

Since pangomm 1.10:

Gravity Pango::Context::get_gravity | ( |  | ) | const

Retrieves the gravity for the context.

This is similar to pango_context_get_base_gravity(), except for when the base gravity is Pango::GRAVITY_AUTO for which pango_gravity_get_for_matrix() is used to return the gravity from the current context matrix.

Returns:
  The resolved gravity for the context.

Since pangomm 1.16:

GravityHint Pango::Context::get_gravity_hint | ( |  | ) | const

Retrieves the gravity hint for the context.

See pango_context_set_gravity_hint() for details.

Returns:
  The gravity hint for the context.

Since pangomm 1.16:

Language Pango::Context::get_language | ( |  | ) | const

Retrieves the global language tag for the context.

Returns:
  The global language tag.

Matrix Pango::Context::get_matrix | ( |  | ) | const

FontMetrics Pango::Context::get_metrics | ( | const FontDescription& | desc,
|  | const Language& | language |
| ) |  |  | const

Get overall metric information for a font particular font description.

Since the metrics may be substantially different for different scripts, a language tag can be provided to indicate that the metrics should be retrieved that correspond to the script(s) used by that language.

The Pango::FontDescription is interpreted in the same way as by pango_itemize(), and the family name may be a comma separated list of figures. If characters from multiple of these families would be used to render the string, then the returned fonts would be a composite of the metrics for the fonts loaded for the individual families.

Parameters:

  | desc | A Pango::FontDescription structure.
  | language | Language tag used to determine which script to get the metrics for.

Returns:
  A Pango::Metrics object.

FontMetrics Pango::Context::get_metrics | ( | const FontDescription& | desc | ) | const

Get overall metric information for a particular font description.

The metrics may be substantially different for different scripts. However this function overload returns the metrics of the entire font.

Parameters:

  | desc | A Pango::FontDescription object.

Returns:
  A Pango::FontMetrics object.

double Pango::Context::get_resolution | ( |  | ) | const

Gets the resolution for the context.

See pango_cairo_context_set_resolution()

Parameters:

  | context | A Pango::Context, from a pangocairo font map.

Returns:
  The resolution in "dots per inch". A negative value will be returned if no resolution has previously been set.

Since pangomm 1.10:

const PangoContext* Pango::Context::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

PangoContext* Pango::Context::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

PangoContext* Pango::Context::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

ListHandle_Item Pango::Context::itemize | ( | const Glib::ustring & | text,
|  | int | start_index,
|  | int | length,
|  | const AttrList& | attrs,
|  | AttrIter& | cached_iter |
| ) |  |  | const

Breaks a piece of text into segments with consistent directional level and shaping engine.

Each byte of text will be contained in exactly one of the items in the returned list. The generated list of items will be in logical order (the start offsets of the items are ascending).

cached_iter should be an iterator over attrs currently positioned at a range before or containing start_index. cached_iter will be advanced to the range covering the position just after start_index + length. (i.e. if itemizing in a loop, just keep passing in the same cached_iter).

Parameters:

  | text | The text to itemize.
  | start_index | First byte in text to process.
  | length | The number of bytes (not characters) to process after start_index. This must be >= `0`.
  | attrs | The set of attributes that apply to text.
  | cached_iter | Cached attribute iterator.

Returns:
  A list of Pango::Item structures.

ListHandle_Item Pango::Context::itemize | ( | const Glib::ustring & | text,
|  | const AttrList& | attrs |
| ) |  |  | const

Breaks a piece of text into segments with consistent directional level and shaping engine.

Each byte of text will be contained in exactly one of the items in the returned list. The generated list of items will be in logical order (the start offsets of the items are ascending).

Parameters:

  | text | The text to itemize.
  | attrs | The set of attributes that apply.

Returns:
  A list of Pango::Item objects.

Glib::ArrayHandle< Glib::RefPtr<FontFamily> > Pango::Context::list_families | ( |  | ) | const

List all available font families for a context.

You can specify one of these as your desired font family in the Pango::FontDesciption objects you use, e.g. in the default font description of the context.

Returns:
  An array of Pango::FontFamily objects.

Glib::RefPtr<Font> Pango::Context::load_font | ( | const FontDescription& | desc | ) | const

Loads the font in one of the fontmaps in the context that is the closest match for desc.

Parameters:

  | desc | A Pango::FontDescription describing the font to load.

Returns:
  The font loaded, or `0` if no font matched.

Glib::RefPtr<Fontset> Pango::Context::load_fontset | ( | const FontDescription& | desc,
|  | const Language& | language |
| ) |  |  | const

Load a set of fonts in the context that can be used to render a font matching desc.

Parameters:

  | desc | A Pango::FontDescription describing the fonts to load.
  | language | A Pango::Language the fonts will be used for.

Returns:
  The fontset, or `0` if no font matched.

void Pango::Context::set_base_dir | ( | Direction | direction | ) |

Sets the base direction for the context.

The base direction is used in applying the Unicode bidirectional algorithm; if the direction is Pango::DIRECTION_LTR or Pango::DIRECTION_RTL, then the value will be used as the paragraph direction in the Unicode bidirectional algorithm. A value of Pango::DIRECTION_WEAK_LTR or Pango::DIRECTION_WEAK_RTL is used only for paragraphs that do not contain any strong characters themselves.

Parameters:

  | direction | The new base direction.

void Pango::Context::set_base_gravity | ( | Gravity | gravity | ) |

Sets the base gravity for the context.

The base gravity is used in laying vertical text out.

Since pangomm 1.16:

Parameters:

  | gravity | The new base gravity.

void Pango::Context::set_cairo_font_options | ( | const Cairo::FontOptions & | options | ) |

Sets the font options used when rendering text with this context.

These options override any options that pango_cairo_update_context() derives from the target surface.

Since pangomm 1.10:

Parameters:

  | context | A Pango::Context, from a pangocairo font map.
  | options | A cairo_font_options_t, or `0` to unset any previously set options. A copy is made.

void Pango::Context::set_font_description | ( | const FontDescription& | desc | ) |

Set the default font description for the context.

Parameters:

  | desc | The new pango font description.

void Pango::Context::set_font_map | ( | const Glib::RefPtr< FontMap >& | font_map | ) |

Sets the font map to be searched when fonts are looked-up in this context.

This is only for internal use by Pango backends, a Pango::Context obtained via one of the recommended methods should already have a suitable font map.

Parameters:

  | font_map | The Pango::FontMap to set.

void Pango::Context::set_gravity_hint | ( | GravityHint | hint | ) |

Sets the gravity hint for the context.

The gravity hint is used in laying vertical text out, and is only relevant if gravity of the context as returned by pango_context_get_gravity() is set Pango::GRAVITY_EAST or Pango::GRAVITY_WEST.

Since pangomm 1.16:

Parameters:

  | hint | The new gravity hint.

void Pango::Context::set_language | ( | const Language& | language | ) |

Sets the global language tag for the context.

The default language for the locale of the running process can be found using pango_language_get_default().

Parameters:

  | language | The new language tag.

void Pango::Context::set_matrix | ( | const Matrix& | matrix | ) |

Sets the transformation matrix that will be applied when rendering with this context.

Note that reported metrics are in the user space coordinates before the application of the matrix, not device-space coordinates after the application of the matrix. So, they don't scale with the matrix, though they may change slightly for different matrices, depending on how the text is fit to the pixel grid.

Since pangomm 1.6:

Parameters:

  | matrix | A Pango::Matrix, or `0` to unset any existing matrix. (No matrix set is the same as setting the identity matrix.).

void Pango::Context::set_resolution | ( | double | dpi | ) |

Sets the resolution for the context.

This is a scale factor between points specified in a Pango::FontDescription and Cairo units. The default value is 96, meaning that a 10 point font will be 13 units high. (10* 96. / 72. = 13.3).

Since pangomm 1.10:

Parameters:

  | context | A Pango::Context, from a pangocairo font map.
  | dpi | The resolution in "dots per inch". (Physical inches aren't actually involved; the terminology is conventional.) A 0 or negative value means to use the resolution from the font map.

void Pango::Context::update_from_cairo_context | ( | const Cairo::RefPtr< Cairo::Context > & | context | ) |

Updates a Pango Context previously created for use with Cairo to match the current transformation and target surface of a Cairo Context.

If any layouts have been created for the context, it's necessary to call Pango::Layout::context_changed() on those layouts.

Parameters:

  | context | A Cairo context, from CairoFontMap::create_context().

## Friends And Related Function Documentation

Glib::RefPtr< Pango::Context > wrap | ( | PangoContext * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- pangomm/context.h